&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME frmbase
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS frmbase 
/*------------------------------------------------------------------------

  File: hl_m0049.w

  Description: RECEPO DE E-FACTURAS

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: Baltazar Oliveira

  Created: 2007.10.13
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

{sw_ini.i}
/* def input parameter d-global    as char. */

/* Local Variable Definitions ---                                       */

def var i                   as  int.

def var o-CaminhoCopiaFAC   as  char.
def var o-CaminhoCopiaNC    as  char.
def var o-flag              as  int init 0.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE DIALOG-BOX
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME frmbase

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS txtnr_recepcao btnsair RECT-1 RECT-2 RECT-29 ~
RECT-3 
&Scoped-Define DISPLAYED-OBJECTS txtcod_recepcao txtnr_recepcao ~
txtnr_factura txtdata_factura txtfornecedor txtnome txtanexo txtiva ~
txttotal edtobs 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of handles for OCX Containers                            */
DEFINE VARIABLE Pdf AS WIDGET-HANDLE NO-UNDO.
DEFINE VARIABLE chPdf AS COMPONENT-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON btnanexo  NO-FOCUS
     LABEL "..." 
     SIZE 3.72 BY 1
     FONT 9.

DEFINE BUTTON btncancelar 
     IMAGE-UP FILE "anular-u":U
     IMAGE-INSENSITIVE FILE "anular-i":U
     LABEL "Cancelar" 
     SIZE 10 BY 1.13 TOOLTIP "Cancelar"
     FONT 4.

DEFINE BUTTON btndata_factura 
     IMAGE-UP FILE "hl_data.bmp":U
     IMAGE-INSENSITIVE FILE "hl_data1.bmp":U NO-FOCUS
     LABEL "Data" 
     SIZE 4.57 BY 1.13.

DEFINE BUTTON btneliminar 
     IMAGE-UP FILE "hx_gelim":U
     IMAGE-INSENSITIVE FILE "hx_geli1":U
     LABEL "Eliminar" 
     SIZE 10 BY 1.13 TOOLTIP "Eliminar"
     FONT 9.

DEFINE BUTTON btngravar 
     IMAGE-UP FILE "hx_ggua":U
     IMAGE-INSENSITIVE FILE "hx_ggua1":U
     LABEL "Gravar" 
     SIZE 10 BY 1.13 TOOLTIP "Gravar"
     FONT 9.

DEFINE BUTTON btnsair 
     IMAGE-UP FILE "hx_gsair":U
     LABEL "Sair" 
     SIZE 10 BY 1.13 TOOLTIP "Sair"
     FONT 9.

DEFINE VARIABLE edtobs AS CHARACTER 
     VIEW-AS EDITOR NO-WORD-WRAP MAX-CHARS 100
     SIZE 53 BY 3 NO-UNDO.

DEFINE VARIABLE txtanexo AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 31 BY 1
     FONT 9 NO-UNDO.

DEFINE VARIABLE txtcod_recepcao AS INTEGER FORMAT "99":U INITIAL 1 
     VIEW-AS FILL-IN NATIVE 
     SIZE 15 BY 1
     FONT 9 NO-UNDO.

DEFINE VARIABLE txtdata_factura AS DATE FORMAT "9999/99/99":U 
     VIEW-AS FILL-IN 
     SIZE 15 BY 1
     FONT 9 NO-UNDO.

DEFINE VARIABLE txtdata_recepcao AS DATE FORMAT "9999/99/99":U 
     VIEW-AS FILL-IN 
     SIZE 15 BY 1
     FONT 9 NO-UNDO.

DEFINE VARIABLE txtdescr_recepcao AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 15 BY 1
     FGCOLOR 7 FONT 6 NO-UNDO.

DEFINE VARIABLE txtfornecedor AS INTEGER FORMAT "99999999":U INITIAL 0 
     VIEW-AS FILL-IN 
     SIZE 15 BY 1
     FONT 9 NO-UNDO.

DEFINE VARIABLE txthora_recepcao AS CHARACTER FORMAT "99:99":U 
     VIEW-AS FILL-IN 
     SIZE 15 BY 1
     FONT 9 NO-UNDO.

DEFINE VARIABLE txtiva AS DECIMAL FORMAT "->>>,>>>,>>9.99999":U INITIAL 0 
     VIEW-AS FILL-IN 
     SIZE 15 BY 1
     FONT 9 NO-UNDO.

DEFINE VARIABLE txtmoeda AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 5 BY 1
     FONT 9 NO-UNDO.

DEFINE VARIABLE txtmoeda1 AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 5 BY 1
     FONT 9 NO-UNDO.

DEFINE VARIABLE txtnome AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 31 BY 1
     FGCOLOR 9 FONT 6 NO-UNDO.

DEFINE VARIABLE txtnovo AS CHARACTER FORMAT "X(16)":U 
     VIEW-AS FILL-IN 
     SIZE 15 BY 1
     FGCOLOR 9 FONT 6 NO-UNDO.

DEFINE VARIABLE txtnr_factura AS CHARACTER FORMAT "X(12)":U 
     VIEW-AS FILL-IN 
     SIZE 15 BY 1
     FONT 9 NO-UNDO.

DEFINE VARIABLE txtnr_recepcao AS INTEGER FORMAT "999999":U INITIAL 0 
     VIEW-AS FILL-IN 
     SIZE 15 BY 1
     FONT 9 NO-UNDO.

DEFINE VARIABLE txttotal AS DECIMAL FORMAT "->>>,>>>,>>9.99999":U INITIAL 0 
     VIEW-AS FILL-IN 
     SIZE 15 BY 1
     FONT 9 NO-UNDO.

DEFINE VARIABLE txtutlz AS CHARACTER FORMAT "X(12)":U 
     VIEW-AS FILL-IN 
     SIZE 15 BY 1
     FONT 9 NO-UNDO.

DEFINE RECTANGLE RECT-1
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 55 BY 6.

DEFINE RECTANGLE RECT-2
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 55 BY 12.96.

DEFINE RECTANGLE RECT-29
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 55 BY 1.57.

DEFINE RECTANGLE RECT-3
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 65 BY 28.3.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME frmbase
     btnanexo AT ROW 12.57 COL 52.29 NO-TAB-STOP 
     btndata_factura AT ROW 9.3 COL 36.14 NO-TAB-STOP 
     txtcod_recepcao AT ROW 2.04 COL 21 NO-LABEL NO-TAB-STOP 
     txtdescr_recepcao AT ROW 2.04 COL 36 NO-LABEL NO-TAB-STOP 
     txtnovo AT ROW 3.09 COL 19 COLON-ALIGNED NO-LABEL
     txtnr_recepcao AT ROW 3.09 COL 19 COLON-ALIGNED NO-LABEL
     txtdata_recepcao AT ROW 4.13 COL 19 COLON-ALIGNED NO-LABEL
     txthora_recepcao AT ROW 5.17 COL 19 COLON-ALIGNED NO-LABEL
     txtutlz AT ROW 6.22 COL 21 NO-LABEL
     txtnr_factura AT ROW 8.35 COL 21 NO-LABEL
     txtdata_factura AT ROW 9.39 COL 19 COLON-ALIGNED NO-LABEL
     txtfornecedor AT ROW 10.48 COL 19 COLON-ALIGNED NO-LABEL
     txtnome AT ROW 11.52 COL 19 COLON-ALIGNED NO-LABEL NO-TAB-STOP 
     txtanexo AT ROW 12.57 COL 19 COLON-ALIGNED NO-LABEL
     txtiva AT ROW 13.61 COL 19 COLON-ALIGNED NO-LABEL
     txtmoeda AT ROW 13.61 COL 36 NO-LABEL NO-TAB-STOP 
     txttotal AT ROW 14.65 COL 19 COLON-ALIGNED NO-LABEL
     txtmoeda1 AT ROW 14.65 COL 36 NO-LABEL NO-TAB-STOP 
     edtobs AT ROW 16.7 COL 3 NO-LABEL
     btngravar AT ROW 28.52 COL 16
     btncancelar AT ROW 28.52 COL 26
     btneliminar AT ROW 28.52 COL 36
     btnsair AT ROW 28.52 COL 46
     RECT-1 AT ROW 1.52 COL 2
     RECT-2 AT ROW 7.87 COL 2
     RECT-29 AT ROW 28.3 COL 2
     RECT-3 AT ROW 1.52 COL 57.43
     "  Detalhes de Recepo" VIEW-AS TEXT
          SIZE 21 BY .61 AT ROW 1.22 COL 3
          FGCOLOR 4 FONT 6
     "IVA Factura :" VIEW-AS TEXT
          SIZE 10 BY 1 AT ROW 13.61 COL 3
          FONT 9
     "Anexo (*):" VIEW-AS TEXT
          SIZE 7 BY 1 AT ROW 12.57 COL 3
          FONT 9
     "Fornecedor :" VIEW-AS TEXT
          SIZE 10 BY 1 AT ROW 10.48 COL 3
          FONT 9
     "Total Factura :" VIEW-AS TEXT
          SIZE 10 BY 1 AT ROW 14.65 COL 3
          FONT 9
     "  Documento" VIEW-AS TEXT
          SIZE 12.29 BY .61 AT ROW 1.22 COL 58.86
          FGCOLOR 4 FONT 6
     "Nome :" VIEW-AS TEXT
          SIZE 7 BY 1 AT ROW 11.52 COL 3
          FONT 9
     "  Detalhes da Factura" VIEW-AS TEXT
          SIZE 20 BY .61 AT ROW 7.65 COL 3
          FGCOLOR 4 FONT 6
     "Observaes" VIEW-AS TEXT
          SIZE 10 BY 1 AT ROW 15.7 COL 3
          FONT 9
     "* - Ao Gravar, o Nome do Anexo ser Cdigo + Nmero da Recepo" VIEW-AS TEXT
          SIZE 53 BY 1 AT ROW 19.65 COL 3
          FONT 9
     "Data Recepo :" VIEW-AS TEXT
          SIZE 12 BY 1 AT ROW 4.13 COL 3
          FONT 9
     "Hora Recepo :" VIEW-AS TEXT
          SIZE 12 BY 1 AT ROW 5.17 COL 3
          FONT 9
     "Nmero Recepo :" VIEW-AS TEXT
          SIZE 15 BY 1 AT ROW 3.09 COL 3
          FONT 9
     "Cdigo Recepo :" VIEW-AS TEXT
          SIZE 14 BY 1 AT ROW 2.04 COL 3
          FONT 9
     "Utilizador :" VIEW-AS TEXT
          SIZE 8 BY 1 AT ROW 6.22 COL 3
          FONT 9
     "Nmero Factura :" VIEW-AS TEXT
          SIZE 13 BY 1 AT ROW 8.35 COL 3
          FONT 9
     "Data Factura :" VIEW-AS TEXT
          SIZE 12 BY 1 AT ROW 9.39 COL 3
          FONT 9
     SPACE(107.43) SKIP(19.56)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         TITLE "Recepo de E-Facturas".


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: DIALOG-BOX
   Allow: Basic,Browse,DB-Fields,Query
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX frmbase
   EXP-POSITION                                                         */
ASSIGN 
       FRAME frmbase:SCROLLABLE       = FALSE
       FRAME frmbase:ROW              = 2.13
       FRAME frmbase:COLUMN           = 1
       FRAME frmbase:HIDDEN           = TRUE.

/* SETTINGS FOR BUTTON btnanexo IN FRAME frmbase
   NO-ENABLE                                                            */
/* SETTINGS FOR BUTTON btncancelar IN FRAME frmbase
   NO-ENABLE                                                            */
/* SETTINGS FOR BUTTON btndata_factura IN FRAME frmbase
   NO-ENABLE                                                            */
/* SETTINGS FOR BUTTON btneliminar IN FRAME frmbase
   NO-ENABLE                                                            */
/* SETTINGS FOR BUTTON btngravar IN FRAME frmbase
   NO-ENABLE                                                            */
/* SETTINGS FOR EDITOR edtobs IN FRAME frmbase
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN txtanexo IN FRAME frmbase
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN txtcod_recepcao IN FRAME frmbase
   NO-ENABLE ALIGN-L                                                    */
/* SETTINGS FOR FILL-IN txtdata_factura IN FRAME frmbase
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN txtdata_recepcao IN FRAME frmbase
   NO-DISPLAY NO-ENABLE                                                 */
/* SETTINGS FOR FILL-IN txtdescr_recepcao IN FRAME frmbase
   NO-DISPLAY NO-ENABLE ALIGN-L                                         */
/* SETTINGS FOR FILL-IN txtfornecedor IN FRAME frmbase
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN txthora_recepcao IN FRAME frmbase
   NO-DISPLAY NO-ENABLE                                                 */
/* SETTINGS FOR FILL-IN txtiva IN FRAME frmbase
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN txtmoeda IN FRAME frmbase
   NO-DISPLAY NO-ENABLE ALIGN-L                                         */
/* SETTINGS FOR FILL-IN txtmoeda1 IN FRAME frmbase
   NO-DISPLAY NO-ENABLE ALIGN-L                                         */
/* SETTINGS FOR FILL-IN txtnome IN FRAME frmbase
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN txtnovo IN FRAME frmbase
   NO-DISPLAY NO-ENABLE                                                 */
/* SETTINGS FOR FILL-IN txtnr_factura IN FRAME frmbase
   NO-ENABLE ALIGN-L                                                    */
/* SETTINGS FOR FILL-IN txttotal IN FRAME frmbase
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN txtutlz IN FRAME frmbase
   NO-DISPLAY NO-ENABLE ALIGN-L                                         */
/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 


/* **********************  Create OCX Containers  ********************** */

&ANALYZE-SUSPEND _CREATE-DYNAMIC

&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN

CREATE CONTROL-FRAME Pdf ASSIGN
       FRAME           = FRAME frmbase:HANDLE
       ROW             = 2
       COLUMN          = 58
       HEIGHT          = 27.44
       WIDTH           = 63
       TAB-STOP        = no
       HIDDEN          = yes
       SENSITIVE       = yes.
      Pdf:NAME = "Pdf":U .
/* Pdf OCXINFO:CREATE-CONTROL from: {CA8A9780-280D-11CF-A24D-444553540000} type: AcroPDF */

&ENDIF

&ANALYZE-RESUME /* End of _CREATE-DYNAMIC */


/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME frmbase
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL frmbase frmbase
ON WINDOW-CLOSE OF FRAME frmbase /* Recepo de E-Facturas */
DO:
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnanexo
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnanexo frmbase
ON CHOOSE OF btnanexo IN FRAME frmbase /* ... */
DO:

    def var x-procura   as  char.
    def var okpressed   as  logical.

    x-procura = "".

    /* -- */
    
    system-dialog get-file x-procura

    title   "Seleccione a Factura"

    filters "Arquivos Adobe PDF (*.pdf)"  "*.pdf"
            
    return-to-start-dir

    must-exist

    use-filename.
    
    if okpressed = true then run value(x-procura).

    /* -- */

    txtanexo:screen-value = x-procura.

    if txtanexo:screen-value <> "" then do:

        pdf:hidden        = false.
        ChPdf:AcroPdf:src = txtanexo:screen-value.
        
    end.
    else pdf:hidden = true.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btncancelar
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btncancelar frmbase
ON CHOOSE OF btncancelar IN FRAME frmbase /* Cancelar */
DO:

    /*
    ----------------------------
    LIMPA OS CAMPOS
    DESACTIVA OS CAMPOS
    
    ACTIVA O CAMPO 'NR RECEPO'
    ----------------------------
    */

    RUN LimpaCampos.
    RUN DesactivaCampos.

    RUN ActivaCampoNrRecepcao.
    
    /* -- */
   
    btngravar:sensitive     = false.  
    btneliminar:sensitive   = false.
    btncancelar:sensitive   = false.
    
    apply "entry":U to txtnr_recepcao.
   
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btndata_factura
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btndata_factura frmbase
ON CHOOSE OF btndata_factura IN FRAME frmbase /* Data */
DO:
  
    txtdata_factura:screen-value = string(today).

    apply "entry":U to txtfornecedor.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btneliminar
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btneliminar frmbase
ON CHOOSE OF btneliminar IN FRAME frmbase /* Eliminar */
DO:
    
    message "Deseja Eliminar a Recepo ? " view-as alert-box question buttons yes-no title
            "Confirmao" update escolha as logical.
            
    case escolha:
    
        when true then do:
            
            find    hl_RecFacNc1    where
                    hl_RecFacNc1.cp_codigo      =   comp    and
                    hl_RecFacNc1.cod_recepcao   =   int(txtcod_recepcao:screen-value)   and
                    hl_RecFacNc1.nr_recepcao    =   int(txtnr_recepcao:screen-value)
                    exclusive-lock no-error.
                    
            delete hl_RecFacNc1.

            /* APAGA O ANEXO */
            
            if search(o-CaminhoCopiaFAC                            + "\" +
                      string(txtcod_recepcao:screen-value,"99")    + "-" +
                      string(txtnr_recepcao:screen-value,"999999") + ".pdf") <> ? then do:
              
                os-delete
                        
                    value(o-CaminhoCopiaFAC                            + "\" +
                          string(txtcod_recepcao:screen-value,"99")    + "-" +
                          string(txtnr_recepcao:screen-value,"999999") + ".pdf").
            end.

            /*
            ----------------------------
            LIMPA OS CAMPOS
            DESACTIVA OS CAMPOS
    
            ACTIVA O CAMPO 'NR RECEPO'
            ----------------------------
            */

            RUN LimpaCampos.
            RUN DesactivaCampos.
            
            RUN ActivaCampoNrRecepcao.
            
            /* -- */
                        
            btngravar:sensitive     = false.
            btncancelar:sensitive   = false.
            btneliminar:sensitive   = false.
            
            apply "entry":U to txtnr_recepcao.

            /* -- */

            message "Recepo Eliminada"
                     view-as alert-box info title "Informao".
            
        end.

    end case.
    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btngravar
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btngravar frmbase
ON CHOOSE OF btngravar IN FRAME frmbase /* Gravar */
DO:

    def var x-numero as int.

    /*
    --------------------------------------------------
    TESTA SE OS CAMPOS ESTO CORRECTAMENTE PREENCHIDOS
    --------------------------------------------------
    */

    if txtnr_factura:screen-value = "" then do:

        message "Nr da Factura Inexistente"
            view-as alert-box error.

        apply "entry":U to txtnr_factura.
        return no-apply.
        
    end.

    /* -- */

    find    ct_terc where
            ct_terc.trc_cod = int(txtfornecedor:screen-value)
            no-lock no-error.
        
    if available ct_terc then do:

        find    ct_natrl where
                ct_natrl.ntr_cod = 2    and
                ct_natrl.trc_cod = ct_terc.trc_cod
                no-lock no-error.

        if not available ct_natrl then do:
                      
            message "O Terceiro no  Fornecedor"
                    view-as alert-box error.
                    
            apply "entry":U to txtfornecedor.
            return no-apply.

        end.
    end.
    else do:
        
        message "Fornecedor Inexistente"
                view-as alert-box error.

        apply "entry":U to txtfornecedor.
        return no-apply.
        
    end.
    
    /* -- */

    if txtanexo:screen-value = "" then do:

        message "Anexo Inexistente"
                view-as alert-box error.

        apply "entry":U to txtanexo.
        return no-apply.
        
    end.

    /* -- */

    if ct_terc.trc_pais = 1 then do: /* PORTUGAL */

        if int(txtiva:screen-value) = 0 then do:

            message "O IVA no pode ser 0"
                    view-as alert-box error.

            apply "entry":U to txtiva.
            return no-apply.
                
        end.
    end.

    /* -- */

    if int(txttotal:screen-value) = 0 then do:

        message "Total da Factura no pode ser 0"
                view-as alert-box error.

        apply "entry":U to txttotal.
        return no-apply.
        
    end.

    /*
    -------------------------------
    CRIAO/ALTERAO DE UM REGISTO
    -------------------------------
    */
        
    if int(txtnr_recepcao:screen-value) = 0 then do:

        find last   hl_RecFacNc1    where
                    hl_RecFacNc1.cp_codigo    = comp and
                    hl_RecFacNc1.cod_recepcao = int(txtcod_recepcao:screen-value)
                    exclusive-lock no-error.

        if not available hl_RecFacNc1 then x-numero = 1.
                                      else x-numero = hl_RecFacNc1.nr_recepcao + 1.
        /* -- */

        create hl_RecFacNc1.
        assign
            hl_RecFacNc1.cp_codigo      =   comp
            hl_RecFacNc1.cod_recepcao   =   int(txtcod_recepcao:screen-value)
            hl_RecFacNc1.nr_recepcao    =   x-numero.

        RUN GravaDados.

        /* -- */
        
        message "Recepo Criada com o Nr. " + string(x-numero,"999999")
                view-as alert-box info title "Informao".
        
    end.
    else do:

        find    hl_RecFacNc1    where
                hl_RecFacNc1.cp_codigo      =   comp    and
                hl_RecFacNc1.cod_recepcao   =   int(txtcod_recepcao:screen-value)   and
                hl_RecFacNc1.nr_recepcao    =   int(txtnr_recepcao:screen-value)
                exclusive-lock no-error.

        RUN GravaDados.
        
    end.
    
    /*
    ----------------------------
    LIMPA OS CAMPOS
    DESACTIVA OS CAMPOS
    
    ACTIVA O CAMPO 'NR RECEPO'
    ----------------------------
    */

    RUN LimpaCampos.
    RUN DesactivaCampos.

    RUN ActivaCampoNrRecepcao.
    
    /* -- */
   
    btngravar:sensitive     = false.  
    btneliminar:sensitive   = false.
    btncancelar:sensitive   = false.
    
    apply "entry":U to txtnr_recepcao.
    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnsair
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnsair frmbase
ON CHOOSE OF btnsair IN FRAME frmbase /* Sair */
DO:
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME txtanexo
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txtanexo frmbase
ON RETURN OF txtanexo IN FRAME frmbase
DO:
  
    apply "choose":U to btnanexo.
    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME txtcod_recepcao
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txtcod_recepcao frmbase
ON RETURN OF txtcod_recepcao IN FRAME frmbase
DO:
    
    find    hl_RecFacNc0    where
            hl_RecFacNc0.cp_codigo    = comp    and
            hl_RecFacNc0.cod_recepcao = int(txtcod_recepcao:screen-value)
            no-lock no-error.

    if available hl_RecFacNc0 then txtdescr_recepcao:screen-value = hl_RecFacNc0.descr_recepcao.
    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME txtdata_factura
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txtdata_factura frmbase
ON RETURN OF txtdata_factura IN FRAME frmbase
DO:
  
    apply "choose":U to btndata_factura.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txtdata_factura frmbase
ON TAB OF txtdata_factura IN FRAME frmbase
DO:
  
    apply "return":U to self.
    return no-apply.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME txtfornecedor
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txtfornecedor frmbase
ON HELP OF txtfornecedor IN FRAME frmbase
DO:
    
    def var x-fornecedor as rowid.

    /* -- */
    
    run hx_h0042.w(output x-fornecedor).
    
    find    ct_terc where
            rowid(ct_terc) = x-fornecedor
            no-lock no-error.

    if rowid(ct_terc) <> ? then if available ct_terc then do:
            
        txtfornecedor:screen-value = string(ct_terc.trc_cod).
        apply "return":U to self.
        
    end.                        
    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txtfornecedor frmbase
ON RETURN OF txtfornecedor IN FRAME frmbase
DO:
    
    find    ct_terc where
            ct_terc.trc_cod = int(self:screen-value)
            no-lock no-error.
                        
    if available ct_terc then do:
        
        find    ct_natrl where
                ct_natrl.ntr_cod = 2    and
                ct_natrl.trc_cod = ct_terc.trc_cod
                no-lock no-error.

        if available ct_natrl then txtnome:screen-value = ct_terc.trc_nome1.
                    
        else do:            

            txtnome:screen-value = "".
            
            message "O Terceiro no  Fornecedor"
                    view-as alert-box error.

            apply "entry":U to self.
            return no-apply.

        end.
                    
    end.
    else do:
        
        txtnome:screen-value = "".
                
        message "Fornecedor Inexistente"
                view-as alert-box error.

         apply "entry":U to self.
         return no-apply.

    end.
   
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txtfornecedor frmbase
ON TAB OF txtfornecedor IN FRAME frmbase
DO:

    apply "return":U to self.
    return no-apply.
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME txtiva
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txtiva frmbase
ON RETURN OF txtiva IN FRAME frmbase
DO:
  
    if available ct_terc then do:

        if ct_terc.trc_pais = 1 then do: /* PORTUGAL */

            if int(txtiva:screen-value) = 0 then do:

                message "O IVA no pode ser 0"
                        view-as alert-box error.

                return no-apply.
                
            end.
        end.
    end.
    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txtiva frmbase
ON TAB OF txtiva IN FRAME frmbase
DO:
  
    apply "return":U to self.
    return no-apply.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME txtnr_factura
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txtnr_factura frmbase
ON RETURN OF txtnr_factura IN FRAME frmbase
DO:
  
    if self:screen-value = "" then do:

        message "Nr da Factura Inexistente"
            view-as alert-box error.

        return no-apply.
        
    end.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txtnr_factura frmbase
ON TAB OF txtnr_factura IN FRAME frmbase
DO:
  
    apply "return":U to self.
    return no-apply.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME txtnr_recepcao
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txtnr_recepcao frmbase
ON RETURN OF txtnr_recepcao IN FRAME frmbase
DO:

    /*
    -------------------
    LIMPA OS CAMPOS
    DESACTIVA OS CAMPOS
    -------------------
    */

    RUN LimpaCampos.
    RUN DesactivaCampos.
    
    /* -- */

    if int(self:screen-value) = 0 then do:

        self:screen-value    = "".
        self:visible         = no.

        txtnovo:screen-value = "Novo Registo".
        txtnovo:visible      = yes.

        /* ACTIVA OS CAMPOS */

        RUN ActivaCampos.

        /* -- */

        btngravar:sensitive   = true.
        btneliminar:sensitive = false.
        btncancelar:sensitive = true.

        /* -- */

        txtdata_recepcao:screen-value = string(today).
        txthora_recepcao:screen-value = string(time,"HH:MM").
        txtutlz:screen-value          = ut-nome.

        apply "entry":U to txtnr_factura.
        
    end. 
    else do:

        find    hl_RecFacNc1 where
                hl_RecFacNc1.cp_codigo       =   comp                                and
                hl_RecFacNc1.cod_recepcao    =   int(txtcod_recepcao:screen-value)   and
                hl_RecFacNc1.nr_recepcao     =   int(txtnr_recepcao:screen-value)
                no-lock no-error.
                
        if not available hl_RecFacNc1 then do:

            RUN ActivaCampoNrRecepcao.

            /* -- */

            message "Recepo Inexistente"
                    view-as alert-box error.

            btngravar:sensitive     = false.
            btncancelar:sensitive   = false.
            btneliminar:sensitive   = false.
            
            /* -- */
            
            apply "entry":U to self.
            return no-apply.

        end.
        else do:
        
            RUN CarregaDados.

            btngravar:sensitive     = true.
            btncancelar:sensitive   = true.
            btneliminar:sensitive   = true.

            /* ACTIVA OS CAMPOS */

            RUN ActivaCampos.
            
        end.
    end.
        
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txtnr_recepcao frmbase
ON TAB OF txtnr_recepcao IN FRAME frmbase
DO:

    apply "return":U to self.
    return no-apply.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME txttotal
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txttotal frmbase
ON RETURN OF txttotal IN FRAME frmbase
DO:
  
    if int(txttotal:screen-value) = 0 then do:

        message "Total da Factura no pode ser 0"
            view-as alert-box error.

        return no-apply.
        
    end.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL txttotal frmbase
ON TAB OF txttotal IN FRAME frmbase
DO:
  
    apply "return":U to self.
    return no-apply.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK frmbase 


/* ***************************  Main Block  *************************** */

/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
IF VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?
THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.


/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
    RUN enable_UI.

    /* CARREGA A DESCRIO DA RECEPO */

    apply "return":U to txtcod_recepcao.

    /*
    ----------------------------
    "ESCONDE" A TEXT-BOX TXTNOVO
    CARREGA O DIA DE HOJE
    ----------------------------
    */
  
    txtnovo:visible               = false.
    txtdata_recepcao:screen-value = string(today).

    /* CARREGA A MOEDA */

    RUN CarregaMoeda.

    /*
    --------------------------------------
    PESQUISA OS PARMETROS GERAIS DE
    RECEPO DAS FACTURAS/NOTAS DE CRDITO
    --------------------------------------
    */

    run hl_s0021.p(output o-CaminhoCopiaFAC,

                   output o-CaminhoCopiaNC,
                   
                   output o-flag).

    /* -- */

    if o-flag = 1 then return no-apply.
    
  WAIT-FOR GO OF FRAME {&FRAME-NAME}.
END.
RUN disable_UI.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ActivaCampoNrRecepcao frmbase 
PROCEDURE ActivaCampoNrRecepcao :
/*------------------------------------------------------------------------------
  Purpose: ACTIVA O CAMPO 'NR_RECEPO'    
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

do with frame frmBase:

    txtnr_recepcao:visible      = true.
    txtnr_recepcao:screen-value = "".
    txtnr_recepcao:sensitive    = true.

    txtnovo:visible             = false.
    
end.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ActivaCampos frmbase 
PROCEDURE ActivaCampos :
/*------------------------------------------------------------------------------
  Purpose: ACTIVA OS CAMPOS
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
do with frame frmbase:

    txtnr_recepcao:sensitive    = true.

    txtnr_factura:sensitive     = true.
    txtdata_factura:sensitive   = true.
    btndata_factura:sensitive   = true.
    
    txtfornecedor:sensitive     = true.
    
    txtanexo:sensitive          = true.
    btnanexo:sensitive          = true.
    
    txtiva:sensitive            = true.
    txttotal:sensitive          = true.

    edtobs:sensitive            = true.
    
end.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CarregaDados frmbase 
PROCEDURE CarregaDados :
/*------------------------------------------------------------------------------
  Purpose: CARREGA OS DADOS
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
do with frame frmbase:

    txtdata_recepcao:screen-value   =   string(hl_RecFacNc1.data_recepcao).   
    txthora_recepcao:screen-value   =   hl_RecFacNc1.hora_recepcao.
    txtutlz:screen-value            =   hl_RecFacNc1.ut_nome.

    edtobs:screen-value             =   hl_RecFacNc1.obs.

    /* -- */

    txtnr_factura:screen-value      =   hl_RecFacNc1.nr_facturaNC.
    txtdata_factura:screen-value    =   string(hl_RecFacNc1.data_facturaNC).

    txtfornecedor:screen-value      =   string(hl_RecFacNc1.trc_cod).
    apply "return":U to txtfornecedor.

    txtanexo:screen-value           =   hl_RecFacNc1.anexo_facturaNC.
    chPdf:AcroPdf:src               =   txtanexo:screen-value.
    Pdf:hidden                      =   false.

    txtiva:screen-value             =   string(hl_RecFacNc1.dcp_tviva).
    txttotal:screen-value           =   string(hl_RecFacNc1.dcp_total).
    
end.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CarregaMoeda frmbase 
PROCEDURE CarregaMoeda :
/*------------------------------------------------------------------------------
  Purpose: CARREGA A MOEDA    
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

do with frame {&frame-name}:

    def var x-codpad        as  int     no-undo.
    def var x-descrpad      as  char    no-undo.
    def var x-abrevpad      as  char    no-undo.
    def var x-arredpad      as  int     no-undo.
    def var x-const1pad     as  dec     no-undo.
    def var x-const2pad     as  dec     no-undo.
    def var x-const3pad     as  dec     no-undo.

    /* -- */
  
    run hx_s0007.p( output x-codpad,
                    output x-descrpad,
                    output x-abrevpad,
                    output x-arredpad,
                    output x-const1pad,
                    output x-const2pad,
                    output x-const3pad).

    /* -- */

    txtmoeda:screen-value  = x-abrevpad.
    txtmoeda1:screen-value = txtmoeda:screen-value.
    
end.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE control_load frmbase  _CONTROL-LOAD
PROCEDURE control_load :
/*------------------------------------------------------------------------------
  Purpose:     Load the OCXs    
  Parameters:  <none>
  Notes:       Here we load, initialize and make visible the 
               OCXs in the interface.                        
------------------------------------------------------------------------------*/

&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN
DEFINE VARIABLE UIB_S    AS LOGICAL    NO-UNDO.
DEFINE VARIABLE OCXFile  AS CHARACTER  NO-UNDO.

OCXFile = SEARCH( "hl_m0049.wrx":U ).
IF OCXFile = ? THEN
  OCXFile = SEARCH(SUBSTRING(THIS-PROCEDURE:FILE-NAME, 1,
                     R-INDEX(THIS-PROCEDURE:FILE-NAME, ".":U), "CHARACTER":U) + "wrx":U).

IF OCXFile <> ? THEN
DO:
  ASSIGN
    chPdf = Pdf:COM-HANDLE
    UIB_S = chPdf:LoadControls( OCXFile, "Pdf":U)
  .
  RUN initialize-controls IN THIS-PROCEDURE NO-ERROR.
END.
ELSE MESSAGE "hl_m0049.wrx":U SKIP(1)
             "The binary control file could not be found. The controls cannot be loaded."
             VIEW-AS ALERT-BOX TITLE "Controls Not Loaded".

&ENDIF

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE DesactivaCampos frmbase 
PROCEDURE DesactivaCampos :
/*------------------------------------------------------------------------------
  Purpose: DESACTIVA OS CAMPOS
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
do with frame frmbase:

    txtnr_recepcao:sensitive    = false.

    txtdata_recepcao:sensitive  = false.
    txthora_recepcao:sensitive  = false.
    txtutlz:sensitive           = false.

    txtnr_factura:sensitive     = false.
    txtdata_factura:sensitive   = false.
    btndata_factura:sensitive   = false.
    
    txtfornecedor:sensitive     = false.
    
    txtanexo:sensitive          = false.
    btnanexo:sensitive          = false.
    
    txtiva:sensitive            = false.
    txttotal:sensitive          = false.

    edtobs:sensitive            = false.
    
end.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI frmbase  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME frmbase.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI frmbase  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  RUN control_load.
  DISPLAY txtcod_recepcao txtnr_recepcao txtnr_factura txtdata_factura 
          txtfornecedor txtnome txtanexo txtiva txttotal edtobs 
      WITH FRAME frmbase.
  ENABLE txtnr_recepcao btnsair RECT-1 RECT-2 RECT-29 RECT-3 
      WITH FRAME frmbase.
  VIEW FRAME frmbase.
  {&OPEN-BROWSERS-IN-QUERY-frmbase}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE GravaAnexo frmbase 
PROCEDURE GravaAnexo :
/*------------------------------------------------------------------------------
  Purpose: GRAVA O ANEXO    
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

do with frame frmBase:

    def var x-nomeficheiro  as char.
    def var compr           as int.

    /*
    ===================================================
    S GRAVA O ANEXO SE TXTANEXO <> DO QUE EST GRAVADO
    EM HL_RECFACNC1  QUE COPIA O FICHEIRO
    ===================================================
    */

    if txtanexo:screen-value <> hl_RecFacNc1.anexo_facturaNC then do:
        
        /*
        ----------------
        COPIA O FICHEIRO
        ----------------
        */

        os-copy

            /* ORIGEM */

            value(txtanexo:screen-value)

            /* DESTINO */

            value(o-CaminhoCopiaFAC).

        /*
        --------------------------------------------------
        TESTA SE O FICHEIRO EXISTIR, SE EXISTIR ELIMINA-O!
        --------------------------------------------------
        */

        if search(o-CaminhoCopiaFAC                            + "\" +
                  string(txtcod_recepcao:screen-value,"99")    + "-" +
                  string(txtnr_recepcao:screen-value,"999999") + ".pdf") <> ? then do:
              
            os-delete

                value(o-CaminhoCopiaFAC                            + "\" +
                      string(txtcod_recepcao:screen-value,"99")    + "-" +
                      string(txtnr_recepcao:screen-value,"999999") + ".pdf").
        end.
    
        /*
        -------------------
        RENOMEIA O FICHEIRO
        -------------------
        */

        /* CAPTURA O NOME DO FICHEIRO */
        
        compr = length(txtanexo:screen-value).
    
        do while substring(txtanexo:screen-value,compr,1) <> "\":
            
            compr = compr - 1.
                          
        end.
    
        x-nomeficheiro = substr(txtanexo:screen-value,compr + 1).

        /* RENOMEIA O FICHEIRO PARA O CDIGO + NR DA RECEPO */

        os-rename 
            
            /* ORIGEM */
    
            value(o-CaminhoCopiaFac + "\" + x-nomeficheiro)

            /* DESTINO */

            value(o-CaminhoCopiaFAC + "\" + string(hl_RecFacNc1.cod_recepcao,"99") + "-" +
                                            string(hl_RecFacNc1.nr_recepcao,"999999") + ".pdf").

        /* APAGA O FICHEIRO INICIAL */

        os-delete

            value(o-CaminhoCopiaFac + "\" + x-nomeficheiro).

        /* TESTA SE O FICHEIRO FOI COPIADO */

        if search(o-CaminhoCopiaFAC + "\" + string(hl_RecFacNc1.cod_recepcao,"99") + "-" +
                                            string(hl_RecFacNc1.nr_recepcao,"999999") + ".pdf") = ? then do:

            message "A Recepo " + string(hl_RecFacNc1.cod_recepcao,"99") + "-" +
                    string(hl_RecFacNc1.nr_recepcao,"999999") + ".pdf" + " no foi copiada" skip

                    "Contacte o Administrador do Sistema"
                    view-as alert-box error.
        
        end.

    end.

end.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE GravaDados frmbase 
PROCEDURE GravaDados :
/*------------------------------------------------------------------------------
  Purpose: GRAVA OS DADOS
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

do with frame frmbase:
    
    hl_RecFacNc1.data_recepcao    = date(txtdata_recepcao:screen-value).
    hl_RecFacNc1.hora_recepcao    = txthora_recepcao:screen-value.
    hl_RecFacNc1.ut_nome          = txtutlz:screen-value.

    hl_RecFacNc1.obs             = edtobs:screen-value.

    /* -- */
    
    hl_RecFacNc1.nr_facturaNC     = txtnr_factura:screen-value.
    hl_RecFacNc1.data_facturaNC   = date(txtdata_factura:screen-value).
    hl_RecFacNc1.trc_cod          = int(txtfornecedor:screen-value).

    RUN GravaAnexo.

    hl_RecFacNc1.anexo_facturaNC = o-CaminhoCopiaFAC + "\" + string(hl_RecFacNc1.cod_recepcao,"99") + "-" +
                                   string(hl_RecFacNc1.nr_recepcao,"999999") + ".pdf".

    hl_RecFacNc1.dcp_tviva       = dec(txtiva:screen-value).
    hl_RecFacNc1.dcp_total       = dec(txttotal:screen-value).

end.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE LimpaCampos frmbase 
PROCEDURE LimpaCampos :
/*------------------------------------------------------------------------------
  Proposito :  LIMPA OS CAMPOS
  Parametros :  
  Notas :       
------------------------------------------------------------------------------*/
do with frame frmbase:

    txtdata_recepcao:screen-value = ?.
    txthora_recepcao:screen-value = "".
    txtutlz:screen-value          = "".

    txtnr_factura:screen-value    = "".
    txtdata_factura:screen-value  = "".

    txtfornecedor:screen-value    = "".
    txtnome:screen-value          = "".

    txtanexo:screen-value         = "".
    pdf:hidden                    = true.

    txtiva:screen-value           = "".
    txttotal:screen-value         = "".

    edtobs:screen-value           = "".
    
end.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

